#include <stdio.h>
#include <string.h>
#include <alsa/asoundlib.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <termios.h>
#include <errno.h>        
#include <stdlib.h> 
#define BAUDRATE B9600 
#define MODEMDEVICE "/dev/ttyACM0"/*UART NAME IN PROCESSOR*/
#define _POSIX_SOURCE 1 /* POSIX compliant source */
#define FALSE 0
#define TRUE 1
void openport(void);
void readport(void);
void midi_init(void);
void playtone(snd_rawmidi_t *midiOutHandle, int tone, int dolzina);
void changetone(snd_rawmidi_t *midiOutHandle);
int fd=0, n;
int current=0;
int curmess=74;
int curvol = 100;
int toneptr = 0;

static int cnt, size, s_cnt;
unsigned char *var;
struct termios oldtp, newtp;
FILE *file;

int  err;
snd_rawmidi_t *midiOutHandle;


void midi_init()
{
// Open output MIDI device hw:0,0,0
if ((err = snd_rawmidi_open(0, &midiOutHandle, "hw:1,0,0", 0)) < 0)
   printf("Can't open MIDI output: %s\n", snd_strerror(err));
else
	snd_rawmidi_nonblock(midiOutHandle, 1);
} 


void process_sound(int mes, int mes2, int button)
{ 

if (button)
{
unsigned char buffer[2];
//stop everything
buffer[0] = 0x80;
buffer[1] = current;
buffer[2] = 0;
snd_rawmidi_write(midiOutHandle, buffer, 3);
snd_rawmidi_drain(midiOutHandle);

changetone(midiOutHandle);
sleep(1);
return;
}

int tone;
int volume;

if(mes2 > 300)
        volume = 100;
else if (mes2 > 250)
        volume = 70;
else if (mes2 > 200)
        volume = 55;
else if (mes2 > 150)
        volume = 60;
else if (mes2 > 110)
	volume = 40;
else if (mes2 > 90)
        volume = 30;
else
{
volume = 0;
if (curvol != 0)
playtone(midiOutHandle, 60, volume);
return;
}

if (mes < 70)
        tone = 60;
else if (mes < 120)
        tone = 62;
else if (mes < 160)
        tone = 64;
else if (mes < 210)
        tone = 65;
else if (mes < 260)
        tone = 67;
else if (mes < 310)
        tone = 69;
else if (mes < 360)
        tone = 71;
else
        tone = 72;



if ((tone == current && curvol == volume) || (mes > curmess && (mes-curmess) < 15) || (curmess >= mes && (curmess - mes) < 15))
//if ((tone == current && curvol == volume))
return;

printf("%d\n", tone);
playtone(midiOutHandle, tone, volume);

curmess = mes;
current = tone;

}


void  readport(void)
{
unsigned char buff;
char str[4];
int c = 0;
int meritev1 = 0;
int meritev2 = 0;
int button = 0;
while (1) { 
  n = read(fd, &buff, 1);
if (n == -1)
{
            continue;
}

if (buff == '|')
{
meritev1 = atoi(str);
c = 0;
memset(str, 0, 4);
}
else if (buff == ',')
{
meritev2 = atoi(str);
c = 0;
memset(str, 0, 4);
}
else if (buff == '\n')
{

button =  atoi(str);
//printf("m1:%dm2:%dbut:%d\n", meritev1, meritev2, button);
process_sound(meritev2, meritev1, button);

//get ready for next
memset(str, 0, 4);
n = read(fd, &buff, 1);
c = 0;
}
else
{
str[c++] = buff;
}
  }
}
void openport(void)
{
         
	 fd = open(MODEMDEVICE, O_RDONLY | O_NONBLOCK |O_NDELAY );
         if (fd <0)
         {
         	perror(MODEMDEVICE);
 
         }
                                                                                
         fcntl(fd,F_SETFL,0);
         tcgetattr(fd,&oldtp); /* save current serial port settings */
    //     tcgetattr(fd,&newtp); /* save current serial port settings */
         bzero(&newtp, sizeof(newtp));
  //       bzero(&oldtp, sizeof(oldtp));
                                                                                
         newtp.c_cflag = BAUDRATE | CRTSCTS | CS8 | CLOCAL | CREAD;
                                                                                
         newtp.c_iflag = IGNPAR | ICRNL;
                                                                                
         newtp.c_oflag = 0;                                                                        
         newtp.c_lflag = ICANON;                                                                    
         newtp.c_cc[VINTR]    = 0;     /* Ctrl-c */
         newtp.c_cc[VQUIT]    = 0;     /* Ctrl-\ */
         newtp.c_cc[VERASE]   = 0;     /* del */
         newtp.c_cc[VKILL]    = 0;     /* @ */
        // newtp.c_cc[VEOF]     = 4;     /* Ctrl-d */
         newtp.c_cc[VTIME]    = 0;     /* inter-character timer unused */
         newtp.c_cc[VMIN]     = 0;     /* blocking read until 1 character arrives */
         newtp.c_cc[VSWTC]    = 0;     /* '\0' */
         newtp.c_cc[VSTART]   = 0;     /* Ctrl-q */
         newtp.c_cc[VSTOP]    = 0;     /* Ctrl-s */
         newtp.c_cc[VSUSP]    = 0;     /* Ctrl-z */
         newtp.c_cc[VEOL]     = 0;     /* '\0' */
         newtp.c_cc[VREPRINT] = 0;     /* Ctrl-r */
         newtp.c_cc[VDISCARD] = 0;     /* Ctrl-u */
         newtp.c_cc[VWERASE]  = 0;     /* Ctrl-w */
         newtp.c_cc[VLNEXT]   = 0;     /* Ctrl-v */
         newtp.c_cc[VEOL2]    = 0;     /* '\0' */
   	                                                                                                                                             
//	  tcflush(fd, TCIFLUSH);
//	 tcsetattr(fd,TCSANOW,&newtp);

}

void changetone(snd_rawmidi_t *midiOutHandle)
{
toneptr++;
int my_array[] = {84,101,66,104};

unsigned char buffer[2];

// Send a middle C note on the first MIDI channel, velocity of 100

buffer[0] = 0xC0;
buffer[1] = my_array[toneptr%4];
snd_rawmidi_write(midiOutHandle, buffer, 2);
}

void playtone(snd_rawmidi_t *midiOutHandle, int tone, int dolzina)
{
unsigned char buffer[3];

buffer[0] = 0x80;
buffer[1] = current;
buffer[2] = 0;
snd_rawmidi_write(midiOutHandle, buffer, 3);
snd_rawmidi_drain(midiOutHandle);
buffer[0] = 0x90;
buffer[1] = tone;
buffer[2] = dolzina;
snd_rawmidi_write(midiOutHandle, buffer, 3);
snd_rawmidi_drain(midiOutHandle);

curvol = dolzina;
}

 
int  main()
{
 
	openport();
	midi_init();
	//changetone(midiOutHandle, 1);
while(1)
	readport();
        return 0;
}

